/*
*	complex.cpp
*
*	Author: M. Reza Mozaffari
*	Physics Group, University of Qom
*	Created on: Dec. 2020
*/

#include "complex.h"

void print(cmplx z)
{
	printf("(%.6f, %.6f)\n", z.x, z.y);
}

cmplx scale(cmplx z, double alpha)
{
//	cmplx q;
//	q.x = z.x*alpha;
//	q.y = z.y*alpha;
	
//	return q;
	return {z.x*alpha, z.y*alpha};
}

cmplx add(cmplx z1, cmplx z2)
{
	return {z1.x + z2.x, z1.y + z2.y};
}

cmplx sub(cmplx z1, cmplx z2)
{
	return {z1.x - z2.x, z1.y - z2.y};
}

cmplx conj(cmplx z)
{
	return {z.x,-z.y};
}

double norm(cmplx z)
{
	return sqrt(z.x*z.x + z.y*z.y);
}

cmplx multi(cmplx z1, cmplx z2)
{
	return {z1.x*z2.x - z1.y*z2.y, z1.x*z2.y + z1.y*z2.x};
}

cmplx div(cmplx z1, cmplx z2)
{
	double r {0.0}, r2 {0.0};
	r = norm(z2);
	r2 = r*r;
	return scale(multi(z1, conj(z2)), 1./r2);
}

double theta(cmplx z)
{
	return atan2(z.y, z.x);
}
